#include <PololuMaestro.h>
#include <Tic.h>

#include <SoftwareSerial.h>
SoftwareSerial maestroTicSerial(3, 5);

MicroMaestro maestro(maestroTicSerial, 12);
TicSerial tic(maestroTicSerial, 14);

#include <PS4BT.h>
#include <usbhub.h>

#ifdef dobogusinclude
#include <spi4teensy3.h>
#endif
#include <SPI.h>

#define FORWARD_MOTOR_DIRCTN HIGH
#define BACKWARD_MOTOR_DIRCTN LOW

/*USB Usb;*/
/*BTD Btd(&Usb);*/ //You have to create the Bluetooth Dongle instance like so

/*You can create the instance of the PS4BT class in two ways */
//This will start an inquiry and then pair with the PS4 controller - you only have to do this once
//You will need to hold down the PS and Share button at the same time, the PS4 controller will then start to blink rapidly indicating that it is in pairing mode
/*PS4BT PS4(&Btd, PAIR);*/

//After that you can simply create the instance like so and then press the PS button on the device
//PS4BT PS4(&Btd);

/*
uint8_t oldR2Value;
*/

/************************************************************/

#include <Wire.h>

#define SAVOX_SA1230SG 1
#define BK_BLS_8001HV_bwd 2
#define BK_BLS_8001HV_fwd 3
#define SAVOX_SW2290SG 4

#define w_servo BK_BLS_8001HV_fwd

#if w_servo == BK_BLS_8001HV_fwd
  const int servoWheelTurnPosZeroVal = 5250;
  const int servoWheelTurnPosMinVal = 6200;
  const int servoWheelTurnPosMaxVal = 4100;
  const int minWheelTurnPosDiff = 0;
#else
#endif

const int wheelSpeedOnPin = A0;
const int wheelSpeedPWMPin = 6;
const int wheelSpeedDirectionPin = A1;

const int wheelTurnPositionChNbr = 0;

/*const int tractorID = 4;*/

int wheelSpeedPre = 127;
int wheelSpeed = 0;
bool wheelDirection = FORWARD_MOTOR_DIRCTN;
int shiftRangeActive = false;
int shiftRange = 1;
int wheelDirIndCntrl = -1;

int wheelTurnPositionPre = 127;
int wheelTurnPosition = servoWheelTurnPosZeroVal;
int wheelTurnPositionNew = wheelTurnPosition;

int loaderLock = true;

int loaderLiftPositionPre = 255;

const int shiftRangeLower1 = 5;
const int shiftRangeUpper4 = 225;
int shiftRangeLower = shiftRangeLower1;
int shiftRangeUpper = shiftRangeUpper4;

bool initProc = true;

void driveWheels();
void turnWheels();
void ck_errs();
void ck_errs2();

int32_t targetPosition = 0;

int debug_track_j1 = false;
uint32_t start = 0;
uint32_t errors = 0;

void setup() {
  // put your setup code here, to run once:
  #if !defined(__MIPSEL__)
    while(!1); //Wait for serial port to connect - used on Leonardo, Teensy and other boards with built-in USB CDC serial connection
  #endif
  if(1 == 2 /*Usb.Init() == -1*/) {
    while(1); //Halt
  }

  //Set the serial baud rate.
  maestroTicSerial.begin(9600);

  // Give the Tic some time to start up.
  delay(20);

  pinMode(wheelSpeedOnPin, OUTPUT);
  pinMode(wheelSpeedPWMPin, OUTPUT);
  pinMode(wheelSpeedDirectionPin, OUTPUT);

  digitalWrite(wheelSpeedOnPin, LOW);

  /*Wire.begin();*/

  maestro.setSpeed(wheelTurnPositionChNbr, 0);
  maestro.setAcceleration(wheelTurnPositionChNbr, 5);

  // Set the Tic's current position to 0, so that when we command
  // it to move later, it will move a predictable amount.
  tic.haltAndSetPosition(0);
  tic.exitSafeStart();
}

void loop() {
  /*Usb.Task();*/
  if(1 == 1 /*PS4.connected()*/) {
    if(initProc == true) {
      uint32_t start = millis();
      loaderLock = !loaderLock;
      
      shiftRangeActive = false;
      shiftRange = 1;
      /*PS4.setLed(Green);*/
      delay(1000);
      initProc = false;
      
      uint32_t errors = tic.getErrorsOccurred();
      /*ck_errs();*/
    }

    if(1 == 2 /*PS4.getButtonClick(PS)*/) {
      /*PS4.disconnect();*/
    }
    else {
      uint32_t errors = tic.getErrorsOccurred();
      /*ck_errs2();*/
      if((uint32_t)(millis() - start) >= 5000) {
        start = millis();
        if(wheelTurnPositionPre != 220) {
          wheelTurnPositionPre = 220;
        }
        else {
          wheelTurnPositionPre = 35;
        }
        /*wheelTurnPositionPre = PS4.getAnalogHat(RightHatX);*/
        
        if(wheelSpeedPre != 220) {
          wheelSpeedPre = 127;
          /*wheelSpeedPre = 220;*/
        }
        else {
          wheelSpeedPre = 127;
          /*wheelSpeedPre = 35;*/
        }
        /*wheelSpeedPre = PS4.getAnalogHat(RightHatY);*/

        if(targetPosition != -700) {
          targetPosition = -700;
          tic.setTargetPosition(-700);
        }
        else {
          targetPosition = -400;
          tic.setTargetPosition(-400);
        }
      }
      
      turnWheels(); /*CMMT OUT MAESTRO Josh 5/21/2022.*/
      driveWheels();
      
      if(1 == 2 /*PS4.getButtonClick(SQUARE)*/) {
        debug_track_j1 = true;
        /*PS4.setLed(125, 0, 125);*/
        loaderLock = !loaderLock;
      }
      
      if(loaderLock != true) {
      }
    }
  }
}



void driveWheels() {
  shiftRangeLower = shiftRangeLower1;
  shiftRangeUpper = shiftRangeUpper4;

  /*Use 10 for minimum to handle controller inner radial dead zone, ignore potential controller outer radial dead zone for now.*/
  wheelSpeed = map(abs(wheelSpeedPre - 127), 10, 127, shiftRangeLower, shiftRangeUpper);
  if(wheelSpeed < shiftRangeLower) {
    wheelSpeed = 0;
  }
  if(wheelSpeed > shiftRangeUpper) {
    wheelSpeed = shiftRangeUpper;
  }

  if((wheelDirIndCntrl * (wheelSpeedPre - 127)) < 0) {
    wheelDirection = FORWARD_MOTOR_DIRCTN;
  }
  else {
    wheelDirection = BACKWARD_MOTOR_DIRCTN;
  }

  digitalWrite(wheelSpeedOnPin, HIGH);
  digitalWrite(wheelSpeedDirectionPin, wheelDirection);
  analogWrite(wheelSpeedPWMPin, wheelSpeed);
}

void turnWheels() {
  if((wheelTurnPositionPre - 127) >= 10) {
    wheelTurnPositionNew = constrain(map(wheelTurnPositionPre, 127 + 10, 255, servoWheelTurnPosZeroVal, servoWheelTurnPosMaxVal), min(servoWheelTurnPosZeroVal, servoWheelTurnPosMaxVal), max(servoWheelTurnPosZeroVal, servoWheelTurnPosMaxVal));    
  }
  else if((wheelTurnPositionPre - 127) <= -10) {
    wheelTurnPositionNew = constrain(map(wheelTurnPositionPre, 0, 127 - 10, servoWheelTurnPosMinVal, servoWheelTurnPosZeroVal), min(servoWheelTurnPosZeroVal, servoWheelTurnPosMinVal), max(servoWheelTurnPosZeroVal, servoWheelTurnPosMinVal));  
  }
  else {
    wheelTurnPositionNew = servoWheelTurnPosZeroVal;
  }

  if(abs(wheelTurnPosition - wheelTurnPositionNew) > minWheelTurnPosDiff || wheelTurnPositionNew == servoWheelTurnPosZeroVal) {
    wheelTurnPosition = wheelTurnPositionNew;
  }
  maestro.setTarget(wheelTurnPositionChNbr, wheelTurnPosition); /*CMMT OUT MAESTRO 5/21/2022.*/  /*This command seems to be what is causing a problem with the Tic*/
}

void ck_errs() {
      if (errors & (1 << (uint8_t)TicError::IntentionallyDeenergized))
      {
        /*PS4.setRumbleOn(RumbleHigh);
        PS4.setLed(Blue);
        PS4.setLedFlash(0, 0);*/
        /*delay(2000);*/
      }
      if (errors & (1 << (uint8_t)TicError::MotorDriverError))
      {
        /*PS4.setRumbleOn(RumbleLow);
        PS4.setLed(Blue);
        PS4.setLedFlash(0, 0);*/
        /*delay(2000);*/
      }
      if (errors & (1 << (uint8_t)TicError::LowVin))
      {
        /*PS4.setRumbleOn(RumbleHigh);
        PS4.setLed(Green);
        PS4.setLedFlash(0, 0);*/
        /*delay(2000);*/
      }
      if (errors & (1 << (uint8_t)TicError::KillSwitch))
      {
        /*PS4.setRumbleOn(RumbleLow);
        PS4.setLed(Green);
        PS4.setLedFlash(0, 0);*/
        /*delay(2000);*/
      }
      if (errors & (1 << (uint8_t)TicError::RequiredInputInvalid))
      {
        /*PS4.setRumbleOn(RumbleHigh);
        PS4.setLed(Red);
        PS4.setLedFlash(0, 0);*/
        /*delay(2000);*/
      }
      if (errors & (1 << (uint8_t)TicError::SerialError))
      {
        /*PS4.setRumbleOn(RumbleLow);*/
        /*PS4.setLed(Red);
        PS4.setLedFlash(0, 0);*/
        /*delay(2000);*/
      }
      if (errors & (1 << (uint8_t)TicError::CommandTimeout))
      {
        /*PS4.setRumbleOn(RumbleHigh);
        PS4.setLed(White);
        PS4.setLedFlash(10, 10);*/
        /*delay(2000);*/
      }
      if (errors & (1 << (uint8_t)TicError::SafeStartViolation))
      {
        /*PS4.setRumbleOn(RumbleLow);*/
        /*PS4.setRumbleOn(0, 0);*/ /*Set Rumble off*/
        /*PS4.setLed(255, 0, 255);
        PS4.setLedFlash(10, 10);*/
        /*delay(2000);*/
      }
      if (errors & (1 << (uint8_t)TicError::ErrLineHigh))
      {
        /*PS4.setRumbleOn(RumbleHigh);
        PS4.setLed(Green);
        PS4.setLedFlash(10, 10);*/
        /*delay(2000);*/
      }
      if (errors & (1 << (uint8_t)TicError::SerialFraming))
      {
        /*PS4.setRumbleOn(RumbleLow);
        PS4.setLed(Green);
        PS4.setLedFlash(10, 10);*/
        /*delay(2000);*/
      }
      if (errors & (1 << (uint8_t)TicError::RxOverrun))
      {
        /*PS4.setRumbleOn(RumbleHigh);
        PS4.setLed(Red);
        PS4.setLedFlash(10, 10);*/
        /*delay(2000);*/
      }
      if (errors & (1 << (uint8_t)TicError::Format))
      {
        /*PS4.setRumbleOn(RumbleLow);
        PS4.setLed(Red);
        PS4.setLedFlash(10, 10);*/
        /*delay(2000);*/
      }
      if (errors & (1 << (uint8_t)TicError::Crc))
      {
        /*PS4.setRumbleOn(RumbleHigh);
        PS4.setLed(Yellow);
        PS4.setLedFlash(0, 0);*/
        /*delay(2000);*/
      }
      if (errors & (1 << (uint8_t)TicError::EncoderSkip))
      {
        /*PS4.setRumbleOn(RumbleLow);
        PS4.setLed(Yellow);
        PS4.setLedFlash(0, 0);*/
        /*delay(2000);*/
      } 
}



void ck_errs2() {
      if (errors & (1 << (uint8_t)TicError::IntentionallyDeenergized))
      {
        /*PS4.setRumbleOn(RumbleHigh);
        PS4.setLed(Blue);
        PS4.setLedFlash(0, 0);*/
        /*delay(2000);*/
      }
      if (errors & (1 << (uint8_t)TicError::MotorDriverError))
      {
        /*PS4.setRumbleOn(RumbleLow);
        PS4.setLed(Blue);
        PS4.setLedFlash(0, 0);*/
        /*delay(2000);*/
      }
      if (errors & (1 << (uint8_t)TicError::LowVin))
      {
        /*PS4.setRumbleOn(RumbleHigh);
        PS4.setLed(Green);
        PS4.setLedFlash(0, 0);*/
        /*delay(2000);*/
      }
      if (errors & (1 << (uint8_t)TicError::KillSwitch))
      {
        /*PS4.setRumbleOn(RumbleLow);
        PS4.setLed(Green);
        PS4.setLedFlash(0, 0);*/
        /*delay(2000);*/
      }
      if (errors & (1 << (uint8_t)TicError::RequiredInputInvalid))
      {
        /*PS4.setRumbleOn(RumbleHigh);
        PS4.setLed(100, 50, 0);
        PS4.setLedFlash(0, 0);*/
        /*delay(2000);*/
      }
      if (debug_track_j1 == false && errors & (1 << (uint8_t)TicError::SerialError))
      {
        /*PS4.setRumbleOn(RumbleLow);*/
        /*PS4.setRumbleOn(0, 0);
        PS4.setLed(Yellow);
        PS4.setLedFlash(10, 10);*/
        /*delay(2000);*/
      }
      if (errors & (1 << (uint8_t)TicError::CommandTimeout))
      {
        /*PS4.setRumbleOn(RumbleHigh);
        PS4.setLed(White);
        PS4.setLedFlash(10, 10);*/
        /*delay(2000);*/
      }
      if (errors & (1 << (uint8_t)TicError::SafeStartViolation))
      {
        /*exclude showing this error for now to see if there is one further up in the error list*/
        /*adjusted so didn't flash, to try to differentiate from initial error*/
        /*
        PS4.setRumbleOn(RumbleLow);
        PS4.setLed(255, 0, 255);
        PS4.setLedFlash(0, 0);
        */
        
        /*delay(2000);*/
      }
      if (errors & (1 << (uint8_t)TicError::ErrLineHigh))
      {
        /*PS4.setRumbleOn(RumbleHigh);
        PS4.setLed(Green);
        PS4.setLedFlash(10, 10);*/
        /*delay(2000);*/
      }
      if (errors & (1 << (uint8_t)TicError::SerialFraming))
      {
        /*PS4.setRumbleOn(RumbleLow);
        PS4.setLed(Green);
        PS4.setLedFlash(10, 10);*/
        /*delay(2000);*/
      }
      if (errors & (1 << (uint8_t)TicError::RxOverrun))
      {
        /*PS4.setRumbleOn(RumbleHigh);
        PS4.setLed(Red);
        PS4.setLedFlash(10, 10);*/
        /*delay(2000);*/
      }
      if (errors & (1 << (uint8_t)TicError::Format))
      {
        /*PS4.setRumbleOn(RumbleLow);
        PS4.setLed(Red);
        PS4.setLedFlash(10, 10);*/
        /*delay(2000);*/
      }
      if (errors & (1 << (uint8_t)TicError::Crc))
      {
        /*PS4.setRumbleOn(RumbleHigh);
        PS4.setLed(Yellow);
        PS4.setLedFlash(0, 0);*/
        /*delay(2000);*/
      }
      if (errors & (1 << (uint8_t)TicError::EncoderSkip))
      {
        /*PS4.setRumbleOn(RumbleLow);
        PS4.setLed(Yellow);
        PS4.setLedFlash(0, 0);*/
        /*delay(2000);*/
      } 
}
